﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_FindDevice.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	1,	Smart-IO2ﾎﾞｰﾄﾞを2台接続した状態で本ｻﾝﾌﾟﾙを実行して下さい。
#	2,	1台目のﾎﾞｰﾄﾞのﾛｰﾀﾘｰｽｲｯﾁを｢6｣に設定
#	3,	2台目のﾎﾞｰﾄﾞのﾛｰﾀﾘｰｽｲｯﾁを｢6｣以外に設定
#	4,	本ｻﾝﾌﾟﾙを実行すると1台目のLEDにﾗﾝﾀﾞﾑﾃﾞｰﾀがﾗｲﾄされます。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	SUPlv_FindDevice()でINDEXﾚｼﾞｽﾀに指定したINDEX値を持つﾃﾞﾊﾞｲｽを検索する。
#	2,	ﾃﾞﾊﾞｲｽが見付かれば、そのﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝする。
#	3,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する。
#	4,	ｱﾄﾞﾚｽ18に8ﾋﾞｯﾄのﾗﾝﾀﾞﾑﾃﾞｰﾀをﾗｲﾄする。
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST


#	DLLを使用する時の定義
from ctypes import *

#	SUPlv.dllをﾛｰﾄﾞしてSUPlv.dll内の関数を呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");

#	ﾀｰｹﾞｯﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_INDEX_ADRS		=	17

#	LEDﾎﾟｰﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_LED_ADRS		=	18

#	検索するINDEX値
_INDEX_ID		=	6

#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_FindDevice.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------');
print('');

#	----------------------------------------------------------------
#	INDEXﾚｼﾞｽﾀに指定したINDEX値を持つﾃﾞﾊﾞｲｽを検索し見付かれば、そのﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾊﾝﾄﾞﾙを取得する
FoundHandle = c_uint64();
if dll.SUPlv_Find_Device( _INDEX_ADRS, _INDEX_ID, byref( FoundHandle )) == False:

	#	INDEX値を持つﾎﾞｰﾄﾞが見付から無かった
	print('NO Find!!');
	sys.exit(1);

#	----------------------------------------------------------------
#	見付けたﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしてPIDを表示する。
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open_Handle( FoundHandle, byref( dWinUSBHandle )) == False:
	print("SUPlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('');


#	----------------------------------------------------------------
#	ｱﾄﾞﾚｽ18に8ﾋﾞｯﾄのﾗﾝﾀﾞﾑﾃﾞｰﾀをﾗｲﾄする。
wd = random.randint( 0, 0xFF );
if dll.SUPlv_Reg_Write( dWinUSBHandle, _LED_ADRS, SUP_CONST.RANGE_8BIT, c_uint64( wd )) == False:

	#	ﾚｼﾞｽﾀﾗｲﾄ失敗
	print('REG-WRITE Failed!!\n');
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

else:
	
	print('Written to %02Xh\n' % wd );

print("FindDevice TEST Successfully!!");
print('');
