﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_Get_FPGA_Temp.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	FPGA温度を取得して表示する
#	4,	1秒待機
#	5,	(3)～(4)を5回繰り返す
#
#	SUPlv_Get_FPGA_Temp()が使用可能なﾎﾞｰﾄﾞは下記のﾎﾞｰﾄﾞです。
#
#	System-SX2ﾎﾞｰﾄﾞ
#	VX-USB2ﾎﾞｰﾄﾞ
#	SX-USB3ﾎﾞｰﾄﾞ
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUP64.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");


#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_Get_FPGA_Temp.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUPlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUP64 device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('')

#	----------------------------------------------------------------
for i in range( 5 ):

	#	----------------------------------------------------------------
	#	FPGA温度を取得する
	temp = c_ushort();
	if dll.SUPlv_Get_FPGA_Temp( dWinUSBHandle, 0, byref( temp )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		sys.exit(1)

	#	----------------------------------------------------------------
	temp_h = temp.value >> 8;
	temp_l = temp.value & 0x00FF;
	print('TEMP = %d.%d degrees' % ( temp_h, temp_l ));

	#	1秒待機
	time.sleep( 1 );

#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );

print('');
print("Get_FPGA_Temp TEST Successfully!!");
print('');
