﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_UsbBulkMem.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	2MB単位で128MBのﾒﾓﾘﾗｲﾄ→ﾒﾓﾘﾘｰﾄﾞ→比較を実行する
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST


#	DLLを使用する時の定義
from ctypes import *

#	SUPlv.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");


_TRANS_SIZE		=	( 1024 * 1024 * 128 )
_SPLIT_SIZE		=	( 1024 * 1024 * 2 )

#	ﾃｽﾄで使用するﾗﾝﾀﾞﾑﾃﾞｰﾀﾌｧｲﾙ
#MEMW_FILE_PATH	= 'D:\\bin\\128MB\\Random1_128MB.bin'
#MEMW_FILE_PATH	= 'D:\\bin\\128MB\\Random2_128MB.bin'
#MEMW_FILE_PATH	= 'D:\\bin\\128MB\\Random3_128MB.bin'
MEMW_FILE_PATH	= 'D:\\bin\\128MB\\Random4_128MB.bin'
MEMR_FILE_PATH	= 'D:\\bin\\128MB\\Read.bin'

#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_UsbBulkMem.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUPlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUPlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('')

#	ﾀｰｹﾞｯﾄﾒﾓﾘ選択
#	ｱﾄﾞﾚｽ1,1ﾊﾞｲﾄﾚｼﾞｽﾀに1をｾｯﾄ
if dll.SUPlv_Reg_Write( dWinUSBHandle, 1, SUP_CONST.RANGE_8BIT, c_uint64( 0x01 )) == False:

	#	ﾚｼﾞｽﾀﾗｲﾄ失敗
	print('Target Memory Select Failed!!\n');
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

#	----------------------------------------------------------------
#	ﾒﾓﾘ操作ﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#
print('MemWriteFile = %s' % MEMW_FILE_PATH );
print('MemReadFile = %s' % MEMR_FILE_PATH );
print('')

#	ﾌｧｲﾙｻｲｽﾞを取得
FileSize = os.path.getsize( MEMW_FILE_PATH );

#	ﾌｧｲﾙをﾊﾞｲﾅﾘﾓｰﾄﾞ+ﾘｰﾄﾞﾓｰﾄﾞにてｵｰﾌﾟﾝ
#	ｵｰﾌﾟﾝに失敗すると実行自体が中断される
ifp = open( MEMW_FILE_PATH, "rb");

#	ﾘｰﾄﾞ用の配列を確保
memw = create_string_buffer( _SPLIT_SIZE );

#	ﾘｰﾄﾞ用の配列を確保
memr = create_string_buffer( _SPLIT_SIZE );


#	ここからの時間をﾃﾞｰﾀ転送時間とする
start_time = time.time();

print('Total = %d Bytes, Split = %d Bytes Memory TEST!!' % ( FileSize, _SPLIT_SIZE ));
print('"." is %d Bytes Transfer.' % _SPLIT_SIZE );
print('');

#	----------------------------------------------------------------
#	ﾒﾓﾘﾗｲﾄ開始ｺﾏﾝﾄﾞを発行
#	----------------------------------------------------------------
if dll.SUPlv_Mem_Cmd( dWinUSBHandle, SUP_CONST.SUPlv_DATA_TRANS_OUT_START, 0x00 ) == False:

	#	ﾒﾓﾘﾗｲﾄ開始ｺﾏﾝﾄﾞ発行失敗
	print('Mem-Cmd(Write Start) Failed!!\n');
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

print('Mem-Cmd(Write Start) Successfully!!\n');

print('MemWriting ', end='');
#	----------------------------------------------------------------
#	ﾒﾓﾘﾗｲﾄ分割ﾙｰﾌﾟ
#	----------------------------------------------------------------
for loop in range( _TRANS_SIZE // _SPLIT_SIZE ):


	#	分割ｻｲｽﾞ単位でﾌｧｲﾙ読込
	memw = ifp.read( _SPLIT_SIZE );

	#	分割ﾒﾓﾘﾗｲﾄ実行
	if dll.SUPlv_Bulk_Write( dWinUSBHandle, _SPLIT_SIZE, memw ) == False:

		#	ﾒﾓﾘﾗｲﾄ失敗
		print(' Failed!!');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		ifp.close();
		sys.exit(1);

	else:

		print('.', end='', flush=True);

print(' Successfully!!');
print('');

#	----------------------------------------------------------------
#	ﾒﾓﾘﾗｲﾄ終了ｺﾏﾝﾄﾞを発行
#	----------------------------------------------------------------
if dll.SUPlv_Mem_Cmd( dWinUSBHandle, SUP_CONST.SUPlv_DATA_TRANS_OUT_END, 0x00 ) == False:

	#	ﾒﾓﾘﾗｲﾄ終了ｺﾏﾝﾄﾞ発行失敗
	print('Mem-Cmd(Write End) Failed!!\n');
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

print('Mem-Cmd(Write End) Successfully!!\n');


#	ﾒﾓﾘﾗｲﾄ成功
elapsed_time = ( time.time() - start_time ) * 1000;
print('MemWrite Transfer time = %dms' % elapsed_time );
print('MemWrite Transfer rate = %3.2fMB/s\n' % ( FileSize  / ( elapsed_time * 1000 )));

#	ﾒﾓﾘﾗｲﾄﾃﾞｰﾀﾌｧｲﾙｸﾛｰｽﾞ
ifp.close();




ofp = open( MEMR_FILE_PATH, "wb");


#	ここからの時間をﾃﾞｰﾀ転送時間とする
start_time = time.time();
#	----------------------------------------------------------------
#	ﾒﾓﾘﾘｰﾄﾞ開始ｺﾏﾝﾄﾞを発行
#	----------------------------------------------------------------
if dll.SUPlv_Mem_Cmd( dWinUSBHandle, SUP_CONST.SUPlv_DATA_TRANS_IN_START, 0x00 ) == False:

	#	ﾒﾓﾘﾗｲﾄ開始ｺﾏﾝﾄﾞ発行失敗
	print('Mem-Cmd(Read Start) Failed!!\n');
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

print('Mem-Cmd(Read Start) Successfully!!\n');

print('MemReading ', end='');

#	----------------------------------------------------------------
#	ﾒﾓﾘﾘｰﾄﾞ分割ﾙｰﾌﾟ
#	----------------------------------------------------------------
for loop in range( _TRANS_SIZE // _SPLIT_SIZE ):

	#	分割ﾒﾓﾘﾗｲﾄ実行
	if dll.SUPlv_Bulk_Read( dWinUSBHandle, _SPLIT_SIZE, memr ) == False:

		#	ﾒﾓﾘﾘｰﾄﾞ失敗
		print(' Failed!!');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		ofp.close();
		sys.exit(1);

	else:

		#	分割ｻｲｽﾞ単位でﾌｧｲﾙ書込み
		ofp.write( memr );
		print('.', end='', flush=True);

print(' Successfully!!');
print('');

#	----------------------------------------------------------------
#	ﾒﾓﾘﾘｰﾄﾞ終了ｺﾏﾝﾄﾞを発行
#	----------------------------------------------------------------
if dll.SUPlv_Mem_Cmd( dWinUSBHandle, SUP_CONST.SUPlv_DATA_TRANS_IN_END, 0x00 ) == False:

	#	ﾒﾓﾘﾘｰﾄﾞ終了ｺﾏﾝﾄﾞ発行失敗
	print('Mem-Cmd(Read End) Failed!!\n');
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

print('Mem-Cmd(Read End) Successfully!!\n');


#	ﾒﾓﾘﾘｰﾄﾞ成功
elapsed_time = ( time.time() - start_time ) * 1000;
print('MemRead Transfer time = %dms' % elapsed_time );
print('MemRead Transfer rate = %3.2fMB/s\n' % ( FileSize  / ( elapsed_time * 1000 )));

#	ﾒﾓﾘﾘｰﾄﾞﾃﾞｰﾀﾌｧｲﾙｸﾛｰｽﾞ
ofp.close();




#	----------------------------------------------------------------
#
#	ﾍﾞﾘﾌｧﾘ処理
#
#	----------------------------------------------------------------
fp1 = open( MEMW_FILE_PATH, "rb");
fp2 = open( MEMR_FILE_PATH, "rb");

print('During verify ', end='', flush=True );

for i in range( _TRANS_SIZE // _SPLIT_SIZE ):

	memw = fp1.read( _SPLIT_SIZE );
	memr = fp2.read( _SPLIT_SIZE );

	for j in range( _SPLIT_SIZE ):

		if memr[j] != memw[j]:

			print('NG!! ADRS=%08Xh, MEMW=%02Xh, MEMR=%02Xh' % (( i*_SPLIT_SIZE+j ), memw[j], memr[j] ));
			fp1.close();
			fp2.close();
			dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
			sys.exit(1);

	print('.', end='', flush=True );

fp1.close();
fp2.close();

print(' Successfully!!');
print('');




#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("SUPlv_Bulk_Write()/SUPlv_Bulk_Read() TEST Successfully!!");
print('');
