﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_UsbBurstRegWrite.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2016.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	本ｻﾝﾌﾟﾙは、Smart-IO2ﾎﾞｰﾄﾞ専用です。
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	64ﾊﾞｲﾄのｲﾝｸﾘﾒﾝﾄﾃﾞｰﾀを生成する
#	4,	Smart-IO2のﾎﾟｰﾄAを出力に設定する
#	5,	(3)で生成したｲﾝｸﾘﾒﾝﾄﾃﾞｰﾀをﾎﾟｰﾄAにﾗｲﾄする
#	
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUP64.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");


#	ﾎﾟｰﾄAOのEﾚｼﾞｽﾀのｱﾄﾞﾚｽ
_PORTA_OE_ADRS		=	8

#	ﾎﾟｰﾄAOのﾃﾞｰﾀﾚｼﾞｽﾀのｱﾄﾞﾚｽ
_PORTA_ADRS			=	0


#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_UsbRegEx.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2016, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUPlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUPlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('');

#	----------------------------------------------------------------
#	64ﾊﾞｲﾄのｲﾝｸﾘﾒﾝﾄﾃﾞｰﾀを生成
wd = ( c_ubyte * 64 )();
for i in range( 64 ):
	wd[i] = c_ubyte( i );

#	----------------------------------------------------------------
#	ﾎﾟｰﾄAのOEﾚｼﾞｽﾀにFFhをﾗｲﾄしてﾎﾟｰﾄAを全て出力に設定する。
if dll.SUPlv_Reg_Write( dWinUSBHandle, _PORTA_OE_ADRS, SUP_CONST.RANGE_8BIT, c_uint64( 0xFF )) == False:
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	print('PORT-A_OE Write failed!!\n\n');
	sys.exit(1);

#	----------------------------------------------------------------
#	64ﾊﾞｲﾄのｲﾝｸﾘﾒﾝﾄﾃﾞｰﾀをﾎﾟｰﾄAにﾗｲﾄする
if dll.SUPlv_Reg_Burst_Write( dWinUSBHandle, _PORTA_ADRS, 64, byref( wd )) == False:
	dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
	print('PORT-A Write failed!!\n\n');
	sys.exit(1);


#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("BURST-REG-WRITE TEST Successfully!!");
print('');

