﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_UsbConfig_CX-Card7.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2016.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■使用方法■
#
#	1,	45行目以降に記述されているPID/暗号化ｵﾌﾟｼｮﾝの有無/ｺﾝﾌｨｸﾞﾌｧｲﾙを環境に合わせて書き換える
#	2,	Pythonをｲﾝｽﾄｰﾙした環境のDOSﾌﾟﾛﾝﾌﾟﾄから実行する
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	接続しているSmart-USBﾃﾞﾊﾞｲｽを順次ｵｰﾌﾟﾝしてPIDを取得&表示する
#	2,	1台目又は予め指定したPIDを持つﾎﾞｰﾄﾞをﾀｰｹﾞｯﾄとする。
#		指定したPIDを持つﾎﾞｰﾄﾞが複数ある場合は指定PIDを持つ最初のﾎﾞｰﾄﾞをﾀｰｹﾞｯﾄとする
#	3,	USBｺﾝﾌｨｸﾞを行う
#	
#	■対象ﾎﾞｰﾄﾞ■
#	KX-Card7
#	
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST

#	----------------------------------------------------------------
#	使用するﾎﾞｰﾄﾞの定義ﾌｧｲﾙを選択する
TARGET_PID		=	0x8001
CFG_FILE_PATH	=	'D:\\temp\\SUPlv_Test\\fpga\\KX-Card7_GPIF2_Verilog.bin'
ENCRYPT			=	SUP_CONST.BIT_ENCRYPT_NO

#	DLLを使用する時の定義
from ctypes import *

#	----------------------------------------------------------------
#	ここまで


#	SUPlv.dllをﾛｰﾄﾞしてSUPlv.dll内の関数を呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");

#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_UsbConfig_KX-Card7.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------');
print('');

#	----------------------------------------------------------------
#	接続しているSUPlvﾃﾞﾊﾞｲｽのﾘｽﾄを取得する
#
#	numには接続しているSUPlvﾃﾞﾊﾞｲｽの台数が返される
#	FoundHandleにはﾃﾞﾊﾞｲｽﾊﾝﾄﾞﾙが返される。
num =  c_ulong();
FoundHandle = ( c_uint64 * 256 )();
dWinUSBHandle = c_uint64();
tWinUSBHandle = c_uint64();		#	ﾀｰｹﾞｯﾄ

if dll.SUPlv_Get_Device_Handle( byref( num ), FoundHandle ) == False:
	print("SUP device not found!!");
	sys.exit(1);
else:
	print('Smart-USB Device %d found!!' % num.value );

print('');

#	----------------------------------------------------------------
#	見つかったﾃﾞﾊﾞｲｽのPIDを取得して表示する。
#	
#	
#	
pid = c_int();
exist_target = False;
for i in range( num.value ):

	if dll.SUPlv_Usb_Open_Handle( c_uint64( FoundHandle[i] ), byref( dWinUSBHandle )) == False:
		#	ﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝ出来なかった
		print("OPEN Failed!!");
		sys.exit(1);

	else:
		#	ﾃﾞﾊﾞｲｽｵｰﾌﾟﾝ成功
		#	PIDを取得する
		if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
			dll.SUPlv_Usb_Close( c_uint64( FoundHandle[i] ), dWinUSBHandle );
			print('SUPlv_Get_BoardInfo() failed!!\n\n');
			sys.exit(1);
		else:

			#	ﾀｰｹﾞｯﾄは既に見付けた?
			if exist_target == False:
				#	まだ見付かっていない
				#	ﾀｰｹﾞｯﾄのPIDか?
				if pid.value == TARGET_PID:

					#	ﾀｰｹﾞｯﾄﾃﾞﾊﾞｲｽが何番目のﾃﾞﾊﾞｲｽかを保存する
					target_num = i;
					exist_tagert = True;
					tWinUSBHandle = c_uint64( dWinUSBHandle.value );
					print('%d - PID:%04Xh Smart-USB Device Found!! <- Target!!' % ( i, pid.value ));

				else:

					print('%d - PID:%04Xh Smart-USB Device Found!!' % ( i, pid.value ));

			else:

				#	発見済み
				print('%d - PID:%04Xh Smart-USB Device Found!!' % ( i, pid.value ));


#	----------------------------------------------------------------







#	----------------------------------------------------------------
#	USBｺﾝﾌｨｸﾞ実行
print('');
print('Configure FilePath = %s' % CFG_FILE_PATH );
print('Configure ........ ', end='');
start_time = time.time();	#	←ここからの時間をﾃﾞｰﾀ転送時間とする
if dll.SUPlv_Usb_Config_KXCARD7( tWinUSBHandle, CFG_FILE_PATH, ENCRYPT ) == 0:

	#	ｺﾝﾌｨｸﾞ失敗
	print(' Failed!!\n');
	sys.exit(1);
else:
	elapsed_time = ( time.time() - start_time ) * 1000;

	#	ｺﾝﾌｨｸﾞ成功
	print(' Successfully!!');
	print('Configure Time = %dms' % elapsed_time );


#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( c_uint64( FoundHandle[i] ), dWinUSBHandle );


