﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_UsbMem.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2016.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	ﾒﾓﾘﾗｲﾄ→ﾒﾓﾘﾘｰﾄﾞ→比較を指定回数(_MEM_LOOP_NUM)実行する
#		ﾒﾓﾘﾌｧｲﾙのﾌｧｲﾙ名やﾚﾝｸﾞｽはﾎﾞｰﾄﾞ定義ﾌｧｲﾙにて定義しています。
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST

#	----------------------------------------------------------------
#	使用するﾎﾞｰﾄﾞの定義ﾌｧｲﾙを選択する
#	どれか1行のみをｺﾒﾝﾄｱｳﾄする
#import	BOARD.CX_CARD4	as	CURRENT
import	BOARD.SX_CARD6	as	CURRENT

#	DLLを使用する時の定義
from ctypes import *

#	SUP64.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");


#	ﾒﾓﾘﾃｽﾄﾙｰﾌﾟ回数
_MEM_LOOP_NUM	=	16



#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_UsbMem.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUPlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUPlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('')


#	----------------------------------------------------------------
#	ﾒﾓﾘ操作ﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#
#	ﾃﾞｰﾀﾌｧｲﾙのﾌｧｲﾙ名やﾒﾓﾘｻｲｽﾞ等はﾎﾞｰﾄﾞ定義ﾌｧｲﾙにて定義している

print( CURRENT.MEM_FILE_PATH );

#	ﾌｧｲﾙｻｲｽﾞを取得
FileSize = os.path.getsize( CURRENT.MEM_FILE_PATH );

#	ﾌｧｲﾙをﾊﾞｲﾅﾘﾓｰﾄﾞ+ﾘｰﾄﾞﾓｰﾄﾞにてｵｰﾌﾟﾝ
#	ｵｰﾌﾟﾝに失敗すると実行自体が中断される
file = open( CURRENT.MEM_FILE_PATH, "rb");

#	ﾊﾞｲﾅﾘﾃﾞｰﾀ読込み
#	全ﾃﾞｰﾀを取り込む
memw = file.read( FileSize );

#	ﾘｰﾄﾞ用の配列を確保
memr = create_string_buffer( FileSize );

print('%dBytes Memory TEST!!' % FileSize );
for loop in range( 0, _MEM_LOOP_NUM ):

	#	ﾒﾓﾘﾗｲﾄ実行
#	print('MemWriting ........ ', end='');
#	start_time = time.time();	#	←ここからの時間をﾃﾞｰﾀ転送時間とする
	if dll.SUPlv_Data_Write( dWinUSBHandle, SUP_CONST.RANGE_8BIT, FileSize, memw ) == False:

		#	ﾒﾓﾘﾗｲﾄ失敗
#		print(' Failed!!');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

#	else:

		#	ﾒﾓﾘﾗｲﾄ成功
#		elapsed_time = ( time.time() - start_time ) * 1000;
#		print(' Successfully!!');
#		print('MemWrite Transfer time = %dms' % elapsed_time );
#		print('MemWrite Transfer rate = %3.2fMB/s\n' % ( FileSize  / ( elapsed_time * 1000 )));


	#	ﾒﾓﾘﾘｰﾄﾞ処理
#	print('Memreading ........ ', end='');
#	start_time = time.time();	#	←ここからの時間をﾃﾞｰﾀ転送時間とする
	if dll.SUPlv_Data_Read( dWinUSBHandle, SUP_CONST.RANGE_8BIT, FileSize, memr ) == False:

		#	ﾒﾓﾘﾘｰﾄﾞ失敗
		print(' Failed!!');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

#	else:

		#	ﾒﾓﾘﾘｰﾄﾞ成功
#		elapsed_time = ( time.time() - start_time ) * 1000;
		print(' Successfully!!');
#		print('MemRead Transfer time = %ldms' % elapsed_time );
#		print('MemRead Transfer rate = %3.2fMB/s\n' % ( FileSize  / ( elapsed_time * 1000 )));

	#	ｺﾝﾍﾟｱ処理
	for i in range( 0, FileSize ):
		if ord( memr[i] ) != memw[i]:
			print('NG!! ADRS=%08Xh, MEMW=%02Xh, MEMR=%02Xh' % ( i, memw[i], memr.value[i] ));

	print('LOOP %04d, Memory Verify Successfully!!' % loop );




#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("MEM TEST Successfully!!");
print('');
