﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_UsbReg.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	ﾚｼﾞｽﾀ4-16ﾋﾞｯﾄﾚｼﾞｽﾀにﾗｲﾄ→ﾘｰﾄﾞ→比較を指定回数(_REG_LOOP_NUM)実行する
#	
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUP64.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");


#	ﾚｼﾞｽﾀﾃｽﾄﾙｰﾌﾟ回数
_REG_LOOP_NUM	=	16

#	ﾀｰｹﾞｯﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_REG_ADRS		=	4



#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_UsbReg.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUPlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUPlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('');

#	----------------------------------------------------------------
#	ﾚｼﾞｽﾀﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#	ﾚｼﾞｽﾀ4-16ﾋﾞｯﾄにｱｸｾｽする
#
#	乱数を生成してﾚｼﾞｽﾀﾗｲﾄ→ﾚｼﾞｽﾀﾘｰﾄﾞして比較を指定回数実行する
#
wd = c_uint64();
rd = c_uint64();
wd_tmp = c_uint16();
rd_tmp = c_uint16();
print('REG LOOP TEST!!');
for i in range( _REG_LOOP_NUM ):

	#	乱数生成
	wd = c_uint64( random.randint( 0, 0xFFFF ));

	#	ﾚｼﾞｽﾀﾗｲﾄ
	#	ｱﾄﾞﾚｽ4,16ﾋﾞｯﾄ固定
	if dll.SUPlv_Reg_Write( dWinUSBHandle, _REG_ADRS, SUP_CONST.RANGE_16BIT, wd ) == False:

		#	ﾚｼﾞｽﾀﾗｲﾄ失敗
		print('REG-WRITE Failed!!\n');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾚｼﾞｽﾀﾘｰﾄﾞ
	#	ｱﾄﾞﾚｽ4,16ﾋﾞｯﾄ固定
	if dll.SUPlv_Reg_Read( dWinUSBHandle, 4, SUP_CONST.RANGE_16BIT, byref( rd )) == False:

		#	ﾚｼﾞｽﾀﾘｰﾄﾞ失敗
		print('REG-READ Failed!!\n');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾍﾞﾘﾌｧｲ処理
	if wd.value == rd.value:

		#	ﾍﾞﾘﾌｧｲOK
		print('LOOP %04d OK:%04Xh,%04Xh' % ( i, wd.value, rd.value ));

	else:
		#	ﾍﾞﾘﾌｧｲNG
		print('LOOP %04d NG:%04Xh,%04Xh' % ( i, wd.value, rd.value ));
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);


#	----------------------------------------------------------------









#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("REG TEST Successfully!!");
print('');

