﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUP_UsbRegEx.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Plusｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUP : Smart-USB Plus
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2016.06.06	M.YOSHIDA
#	
#	→	SUPﾃﾞﾊﾞｲｽの操作には｢SUPlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUPlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Plus_xxxx.zip｣を使用してSUPﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	ﾚｼﾞｽﾀ16-64ﾊﾞｲﾄﾚｼﾞｽﾀにﾗｲﾄ→ﾘｰﾄﾞ→比較を指定回数(_REG_LOOP_NUM)実行する
#	
#	動作確認用のｻﾝﾌﾟﾙ回路として下記を用意しています。
#	本ｻﾝﾌﾟﾙを実行する前に予めｺﾝﾌｨｸﾞﾚｰｼｮﾝを実行して下さい。
#	
#	CX-Card4/EP4CE40用		GPIF_VerilogEx_CX-Card4_EP4CE40.rbf
#	SX-Card6/LX75用			GPIF_VerilogEx_SX-Card6_LX75.bin
#
#	SUPlv_Reg_WriteEx()及びSUPlv_Reg_ReadEx()が使用可能なﾎﾞｰﾄﾞは下記のﾎﾞｰﾄﾞです。
#	括弧内はUSBﾌｧｰﾑｳｪｱのﾊﾞｰｼﾞｮﾝ
#
#	SX-USB2ﾎﾞｰﾄﾞ(0204以降)
#	CX-Card2(0204以降)
#	VX-USB2ﾎﾞｰﾄﾞ(0201以降)
#	SX-USB3ﾎﾞｰﾄﾞ(0204以降)
#	SX-Card3(0205以降)
#	ASUP-M3(0202以降)
#	CX-Card4(0202以降)
#	SX-Card6(0201以降)
#	CX-USB2(0202以降)
#	mxcard
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUP_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUP64.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUPlv.dll");


#	ﾚｼﾞｽﾀﾃｽﾄﾙｰﾌﾟ回数
_REG_LOOP_NUM	=	16

#	ﾀｰｹﾞｯﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_REG_ADRS		=	16



#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUP_UsbRegEx.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUPlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUPlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUPlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUPlv_Get_BoardInfo( dWinUSBHandle, SUP_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUPlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUPlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUPlv Device Found!!' % pid.value );

print('');

#	----------------------------------------------------------------
#	ﾚｼﾞｽﾀﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#	ﾚｼﾞｽﾀ4-16ﾋﾞｯﾄにｱｸｾｽする
#
#	乱数を生成してﾚｼﾞｽﾀﾗｲﾄ→ﾚｼﾞｽﾀﾘｰﾄﾞして比較を指定回数実行する
#
rd = c_int();
wd = ( c_ubyte * 64 )();
rd = ( c_ubyte * 64 )();
print('REGEX LOOP TEST!!');
for i in range( _REG_LOOP_NUM ):

	#	ﾗｲﾄする64ﾊﾞｲﾄの乱数生成
	for j in range( 64 ):
		wd[j] = random.randint( 0, 0xFF );

	#	ﾚｼﾞｽﾀﾗｲﾄ
	#	ｱﾄﾞﾚｽ16,64ﾊﾞｲﾄ固定
	if dll.SUPlv_Reg_WriteEx( dWinUSBHandle, _REG_ADRS, 64, byref( wd )) == False:

		#	ﾚｼﾞｽﾀﾗｲﾄ失敗
		print('REG-WRITE-EX Failed!!\n');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);


	#	ﾚｼﾞｽﾀﾘｰﾄﾞ
	#	ｱﾄﾞﾚｽ16,64ﾊﾞｲﾄ固定
	if dll.SUPlv_Reg_ReadEx( dWinUSBHandle, _REG_ADRS, 64, byref( rd )) == False:

		#	ﾚｼﾞｽﾀﾘｰﾄﾞ失敗
		print('REG-READ-EX Failed!!\n');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾍﾞﾘﾌｧｲ処理
	error = False;
	for j in range( 64 ):

		if wd[j] != rd[j]:

			#	ﾍﾞﾘﾌｧｲNG
			error = True;

	#	64ﾊﾞｲﾄが全て一致したか?
	if error == True:

		#	ﾍﾞﾘﾌｧｲNG
		print('LOOP %04d NG:%04Xh,%04Xh' % ( i, wd[j], rd[j] ));
		print('REGEX TEST Failed!!\n');
		dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);
	else:

		#	ﾍﾞﾘﾌｧｲOK
		print('LOOP %04d OK' % i );

#	ｸﾛｰｽﾞして終了
dll.SUPlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("REGEX TEST Successfully!!");
print('');

